﻿using Microsoft.Xrm.Sdk;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CrmIntegration.Helpers
{
    public class AccountInfo
    {
        // "name"           
        public string Name { get; set; }

        // "address1_postalcode"
        public string Zip { get; set; }

        // "address1_city"
        public string City { get; set; }

        // "new_country"
        public string Country { get; set; }

        public string ID { get; set; }

        // "accountcategorycode"
        public string Category { get; set; }

        // "new_partnertype"
        public string PartnerType { get; set; }

        // "nn_primarytradecodeno"
        public string Nacecode { get; set; }

        // "new_erpsystem"
        public string ErpSystem { get; set; }

        //new_primarylineofbusiness
        public string PrimaryLineOfBusiness { get; set; }

        //accountnumber PartnerAccountNumber
        public string Number { get; set; }
    }
    public class UserInfoHelper
    {        
        public static Hashtable GetAccountsHashTable(EntityCollection accounts)
        {
            Hashtable ret = new Hashtable();
            if (accounts != null && accounts.Entities != null)
            {
                string accountId = null;
                foreach (Entity a in accounts.Entities)
                {
                    accountId = a.GetAttributeValue("accountid");
                    if (!string.IsNullOrEmpty(accountId) && !ret.ContainsKey(accountId))
                    {
                        AccountInfo info = new AccountInfo();
                        info.ID = accountId;
                        info.Category = a.GetAttributeValue("accountcategorycode");
                        info.Country = a.GetAttributeValue("new_country");
                        info.PartnerType = a.GetAttributeValue("new_partnertype");
                        info.Nacecode = a.GetAttributeValue("nn_primarytradecodeno");
                        info.ErpSystem = a.GetAttributeValue("new_erpsystem");
                        info.Name = a.GetAttributeValue("name");
                        info.Number = a.GetAttributeValue("accountnumber");
                        info.Zip = a.GetAttributeValue("address1_postalcode");
                        info.City = a.GetAttributeValue("address1_city");
                        info.PrimaryLineOfBusiness = a.GetAttributeValue("new_primarylineofbusiness");

                        ret.Add(accountId, info);
                    }
                }
            }
            return ret;
        }
    }
}
